// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/driver/16aiss8ao4.h $
// $Rev: 54019 $
// $Date: 2023-12-12 09:15:32 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Device Driver: header file

#ifndef	__16AISS8AO4_H__
#define	__16AISS8AO4_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	AISS8AO4_BASE_NAME					"16aiss8ao4"

// IOCTL command codes
#define	AISS8AO4_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	AISS8AO4_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	AISS8AO4_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	AISS8AO4_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	AISS8AO4_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	AISS8AO4_IOCTL_AUTOCAL				OS_IOCTL   ( 5)
#define	AISS8AO4_IOCTL_AUTOCAL_STATUS		OS_IOCTL_R ( 6,  4, s32)
#define	AISS8AO4_IOCTL_AUTOCAL_AI			OS_IOCTL   ( 7)
#define	AISS8AO4_IOCTL_AI_BUF_CLEAR			OS_IOCTL   ( 8)
#define	AISS8AO4_IOCTL_AI_BUF_LEVEL			OS_IOCTL_R ( 9,  4, s32)
#define	AISS8AO4_IOCTL_AI_BUF_OVERFLOW		OS_IOCTL_RW(10,  4, s32)
#define	AISS8AO4_IOCTL_AI_BUF_THR_LVL		OS_IOCTL_RW(11,  4, s32)
#define	AISS8AO4_IOCTL_AI_BUF_THR_STS		OS_IOCTL_R (12,  4, s32)
#define	AISS8AO4_IOCTL_AI_BUF_UNDERFLOW		OS_IOCTL_RW(13,  4, s32)
#define	AISS8AO4_IOCTL_AI_BURST_ENABLE		OS_IOCTL_RW(14,  4, s32)
#define	AISS8AO4_IOCTL_AI_BURST_SIZE		OS_IOCTL_RW(15,  4, s32)
#define	AISS8AO4_IOCTL_AI_BURST_STATUS		OS_IOCTL_R (16,  4, s32)
#define	AISS8AO4_IOCTL_AI_CHAN_SEL			OS_IOCTL_RW(17,  4, s32)
#define	AISS8AO4_IOCTL_AI_CLOCK_SRC			OS_IOCTL_RW(18,  4, s32)
#define	AISS8AO4_IOCTL_AI_ENABLE			OS_IOCTL_RW(19,  4, s32)
#define	AISS8AO4_IOCTL_AI_MODE				OS_IOCTL_RW(20,  4, s32)
#define	AISS8AO4_IOCTL_AI_RANGE_A			OS_IOCTL_RW(21,  4, s32)
#define	AISS8AO4_IOCTL_AI_RANGE_B			OS_IOCTL_RW(22,  4, s32)
#define	AISS8AO4_IOCTL_AI_SW_CLOCK			OS_IOCTL   (23)
#define	AISS8AO4_IOCTL_AI_SW_TRIGGER		OS_IOCTL   (24)
#define	AISS8AO4_IOCTL_AO_ACCESS_MODE		OS_IOCTL_RW(25,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_CLEAR			OS_IOCTL   (26)
#define	AISS8AO4_IOCTL_AO_BUF_DATA_OVER		OS_IOCTL_RW(27,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_FRAME_OVER	OS_IOCTL_RW(28,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_LEVEL			OS_IOCTL_R (29,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_MODE			OS_IOCTL_RW(30,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_THR_LVL		OS_IOCTL_RW(31,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_THR_STS		OS_IOCTL_R (32,  4, s32)
#define	AISS8AO4_IOCTL_AO_BUF_STATUS		OS_IOCTL_R (33,  4, s32)
#define	AISS8AO4_IOCTL_AO_BURST_ENABLE		OS_IOCTL_RW(34,  4, s32)
#define	AISS8AO4_IOCTL_AO_BURST_STATUS		OS_IOCTL_R (35,  4, s32)
#define	AISS8AO4_IOCTL_AO_CHAN_SEL			OS_IOCTL_RW(36,  4, s32)
#define	AISS8AO4_IOCTL_AO_CLOCK_ENABLE		OS_IOCTL_RW(37,  4, s32)
#define	AISS8AO4_IOCTL_AO_CLOCK_READY		OS_IOCTL_RW(38,  4, s32)
#define	AISS8AO4_IOCTL_AO_CLOCK_SRC			OS_IOCTL_RW(39,  4, s32)
#define	AISS8AO4_IOCTL_AO_LOAD_READY		OS_IOCTL_R (40,  4, s32)
#define	AISS8AO4_IOCTL_AO_LOAD_REQUEST		OS_IOCTL_R (41,  4, s32)
#define	AISS8AO4_IOCTL_AO_RANGE				OS_IOCTL_RW(42,  4, s32)
#define	AISS8AO4_IOCTL_AO_SW_CLOCK			OS_IOCTL   (43)
#define	AISS8AO4_IOCTL_AO_SW_TRIGGER		OS_IOCTL   (44)
#define	AISS8AO4_IOCTL_AO_TIMING			OS_IOCTL_RW(45,  4, s32)
#define	AISS8AO4_IOCTL_DATA_FORMAT			OS_IOCTL_RW(46,  4, s32)
#define	AISS8AO4_IOCTL_DIO_DIR_OUT			OS_IOCTL_RW(47,  4, s32)
#define	AISS8AO4_IOCTL_DIO_READ				OS_IOCTL_R (48,  4, s32)
#define	AISS8AO4_IOCTL_DIO_WRITE			OS_IOCTL_RW(49,  4, s32)
#define	AISS8AO4_IOCTL_GEN_A_ENABLE			OS_IOCTL_RW(50,  4, s32)
#define	AISS8AO4_IOCTL_GEN_A_NDIV			OS_IOCTL_RW(51,  4, s32)
#define	AISS8AO4_IOCTL_GEN_B_ENABLE			OS_IOCTL_RW(52,  4, s32)
#define	AISS8AO4_IOCTL_GEN_B_NDIV			OS_IOCTL_RW(53,  4, s32)
#define	AISS8AO4_IOCTL_GEN_C_ENABLE			OS_IOCTL_RW(54,  4, s32)
#define	AISS8AO4_IOCTL_GEN_C_NDIV			OS_IOCTL_RW(55,  4, s32)
#define	AISS8AO4_IOCTL_IRQ_ENABLE			OS_IOCTL_RW(56,  4, s32)
#define	AISS8AO4_IOCTL_RX_IO_ABORT			OS_IOCTL_R (57,  4, s32)
#define	AISS8AO4_IOCTL_RX_IO_MODE			OS_IOCTL_RW(58,  4, s32)
#define	AISS8AO4_IOCTL_RX_IO_OVERFLOW		OS_IOCTL_RW(59,  4, s32)
#define	AISS8AO4_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW(60,  4, s32)
#define	AISS8AO4_IOCTL_RX_IO_UNDERFLOW		OS_IOCTL_RW(61,  4, s32)
#define	AISS8AO4_IOCTL_TRIGGER_SRC			OS_IOCTL_RW(62,  4, s32)
#define	AISS8AO4_IOCTL_TX_IO_ABORT			OS_IOCTL_R (63,  4, s32)
#define	AISS8AO4_IOCTL_TX_IO_DATA_OVER		OS_IOCTL_RW(64,  4, s32)
#define	AISS8AO4_IOCTL_TX_IO_FRAME_OVER		OS_IOCTL_RW(65,  4, s32)
#define	AISS8AO4_IOCTL_TX_IO_MODE			OS_IOCTL_RW(66,  4, s32)
#define	AISS8AO4_IOCTL_TX_IO_TIMEOUT		OS_IOCTL_RW(67,  4, s32)
#define	AISS8AO4_IOCTL_WAIT_EVENT			OS_IOCTL_RW(68, 28, gsc_wait_t)
#define	AISS8AO4_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(69, 28, gsc_wait_t)
#define	AISS8AO4_IOCTL_WAIT_STATUS			OS_IOCTL_RW(70, 28, gsc_wait_t)
#define	AISS8AO4_IOCTL_BURST_SYNC			OS_IOCTL_RW(71,  4, s32)

//*****************************************************************************
// AISS8AO4_IOCTL_REG_READ
// AISS8AO4_IOCTL_REG_WRITE
// AISS8AO4_IOCTL_REG_MOD
//
#define	AISS8AO4_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AISS8AO4_GSC_BCR					AISS8AO4_REG_ENCODE(4,0x00)// Board Control Register
#define	AISS8AO4_GSC_DIOPR					AISS8AO4_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	AISS8AO4_GSC_OC0DR					AISS8AO4_REG_ENCODE(4,0x08)// Output Channel 0 Data Register
#define	AISS8AO4_GSC_OC1DR					AISS8AO4_REG_ENCODE(4,0x0C)// Output Channel 1 Data Register
#define	AISS8AO4_GSC_OC2DR					AISS8AO4_REG_ENCODE(4,0x10)// Output Channel 2 Data Register
#define	AISS8AO4_GSC_OC3DR					AISS8AO4_REG_ENCODE(4,0x14)// Output Channel 3 Data Register
#define	AISS8AO4_GSC_IBDR					AISS8AO4_REG_ENCODE(4,0x18)// Input Buffer Data Register
#define	AISS8AO4_GSC_RAGR					AISS8AO4_REG_ENCODE(4,0x1C)// Rate-A Generator Register
#define	AISS8AO4_GSC_RBGR					AISS8AO4_REG_ENCODE(4,0x20)// Rate-B Generator Register
#define	AISS8AO4_GSC_ICR					AISS8AO4_REG_ENCODE(4,0x24)// Input Configuration Register
#define	AISS8AO4_GSC_IBSR					AISS8AO4_REG_ENCODE(4,0x28)// Input Buffer Size Register
#define	AISS8AO4_GSC_IBTR					AISS8AO4_REG_ENCODE(4,0x2C)// Input Buffer Threshold Register
#define	AISS8AO4_GSC_PSR					AISS8AO4_REG_ENCODE(4,0x30)// Primary Status Register
#define	AISS8AO4_GSC_ACR					AISS8AO4_REG_ENCODE(4,0x34)// Assembly Configuration Register
#define	AISS8AO4_GSC_AVR					AISS8AO4_REG_ENCODE(4,0x38)// Auto Cal Values Register
#define	AISS8AO4_GSC_BOOR					AISS8AO4_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	AISS8AO4_GSC_OBTR					AISS8AO4_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	AISS8AO4_GSC_OBSR					AISS8AO4_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	AISS8AO4_GSC_OBDR					AISS8AO4_REG_ENCODE(4,0x48)// Output Buffer Data Register
#define	AISS8AO4_GSC_RCGR					AISS8AO4_REG_ENCODE(4,0x4C)// Rate-C Generator Register
#define	AISS8AO4_GSC_AU0R					AISS8AO4_REG_ENCODE(4,0x50)// Auxiliary User 0 Register
#define	AISS8AO4_GSC_AU1R					AISS8AO4_REG_ENCODE(4,0x54)// Auxiliary User 1 Register
#define	AISS8AO4_GSC_AU2R					AISS8AO4_REG_ENCODE(4,0x58)// Auxiliary User 2 Register
#define	AISS8AO4_GSC_AU3R					AISS8AO4_REG_ENCODE(4,0x5C)// Auxiliary User 3 Register

//*****************************************************************************
// AISS8AO4_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AISS8AO4_QUERY_AUTOCAL_AI,				// Is the AI Autocal option present?
	AISS8AO4_QUERY_AUTOCAL_MS,				// Max autocalibrate period in ms.
	AISS8AO4_QUERY_CHANNEL_AI_MAX,			// Maximum number of input channels supported.
	AISS8AO4_QUERY_CHANNEL_AI_QTY,			// The number of input channels supported.
	AISS8AO4_QUERY_CHANNEL_AO_MAX,			// Maximum number of output channels supported.
	AISS8AO4_QUERY_CHANNEL_AO_QTY,			// The number of output channels supported.
	AISS8AO4_QUERY_COUNT,					// How many query options are supported?
	AISS8AO4_QUERY_DEVICE_TYPE,				// Value from gsc_dev_type_t
	AISS8AO4_QUERY_DMDMA,					// Is DMDMA supported?
	AISS8AO4_QUERY_FGEN_MAX_AI,				// AI Rate Generator maximum output rate.
	AISS8AO4_QUERY_FGEN_MAX_AO,				// AO Rate Generator maximum output rate.
	AISS8AO4_QUERY_FGEN_MIN_AI,				// AI Rate Generator minimum output rate.
	AISS8AO4_QUERY_FGEN_MIN_AO,				// AO Rate Generator minimum output rate.
	AISS8AO4_QUERY_FIFO_SIZE_RX,			// Rx FIFO depth in 32-bit samples
	AISS8AO4_QUERY_FIFO_SIZE_TX,			// Rx FIFO depth in 32-bit samples
	AISS8AO4_QUERY_FSAMP_MAX_AI,			// The maximum sample rate per input channel.
	AISS8AO4_QUERY_FSAMP_MAX_AO,			// The maximum sample rate per output channel.
	AISS8AO4_QUERY_FSAMP_MIN_AI,			// The minimum sample rate per input channel.
	AISS8AO4_QUERY_FSAMP_MIN_AO,			// The minimum sample rate per output channel.
	AISS8AO4_QUERY_INIT_MS,					// Max initialize period in ms.
	AISS8AO4_QUERY_MASTER_CLOCK,			// Master clock frequency
	AISS8AO4_QUERY_NDIV_MAX_AI,				// Maximum input rate generator Ndiv value.
	AISS8AO4_QUERY_NDIV_MAX_AO,				// Maximum output rate generator Ndiv value.
	AISS8AO4_QUERY_NDIV_MIN_AI,				// Maximum input rate generator Ndiv value.
	AISS8AO4_QUERY_NDIV_MIN_AO,				// Maximum output rate generator Ndiv value.
	AISS8AO4_QUERY_RATE_GEN_QTY,			// Number of Rate Generatorts.
	AISS8AO4_QUERY_REG_AUX_USER,			// Number of Aux User regs present
	AISS8AO4_QUERY_SYS_IO_CFG,				// System I/O Configuration
	AISS8AO4_QUERY_BURST_SYNC,				// Is Synchronize AI and AO bursting present?

	AISS8AO4_IOCTL_QUERY_LAST

} aiss8ao4_query_t;

#define	AISS8AO4_IOCTL_QUERY_ERROR			(-1)

// AISS8AO4_QUERY_SYS_IO_CFG
#define	AISS8AO4_SYS_IO_CFG_STANDARD		0
#define	AISS8AO4_SYS_IO_CFG_ALT_SMA			1

// Retained for backwards compatibility:
#define	AISS8AO4_QUERY_AUTO_CAL_AI			AISS8AO4_QUERY_AUTOCAL_AI
#define	AISS8AO4_QUERY_AUTO_CAL_MS			AISS8AO4_QUERY_AUTOCAL_MS

//*****************************************************************************
// AISS8AO4_IOCTL_INITIALIZE				BCR D31
//
//	Parameter:	None

//*****************************************************************************
// AISS8AO4_IOCTL_AUTOCAL					BCR D28
//
//	Parameter:	None

// Retained for backwards compatibility:
#define	AISS8AO4_IOCTL_AUTO_CALIBRATE		AISS8AO4_IOCTL_AUTOCAL

//*****************************************************************************
// AISS8AO4_IOCTL_AUTOCAL_STATUS			BCR D28, D29
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AISS8AO4_AUTOCAL_STATUS_ACTIVE		0
#define	AISS8AO4_AUTOCAL_STATUS_FAIL		1
#define	AISS8AO4_AUTOCAL_STATUS_PASS		2

// Retained for backwards compatibility:
#define	AISS8AO4_IOCTL_AUTO_CAL_STS			AISS8AO4_IOCTL_AUTOCAL_STATUS
#define	AISS8AO4_AUTO_CAL_STS_ACTIVE		AISS8AO4_AUTOCAL_STATUS_ACTIVE
#define	AISS8AO4_AUTO_CAL_STS_FAIL			AISS8AO4_AUTOCAL_STATUS_FAIL
#define	AISS8AO4_AUTO_CAL_STS_PASS			AISS8AO4_AUTOCAL_STATUS_PASS

//*****************************************************************************
// AISS8AO4_IOCTL_AUTOCAL_AI				BCR D3
//
//	Parameter:	None

// Retained for backwards compatibility:
#define	AISS8AO4_IOCTL_AUTO_CALIBRATE_AI	AISS8AO4_IOCTL_AUTOCAL_AI

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BUF_CLEAR				BCR D13
// AISS8AO4_IOCTL_AO_BUF_CLEAR				BOOR D11
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BUF_LEVEL				IBSR D0-D18
// AISS8AO4_IOCTL_AO_BUF_LEVEL				OBSR D0-D18
//
//	Parameter:	s32*
//		The value returned is the current buffer fill level.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BUF_OVERFLOW			BCR D15
// AISS8AO4_IOCTL_AI_BUF_UNDERFLOW			BCR D23
// AISS8AO4_IOCTL_AO_BUF_DATA_OVER			BOOR D16
// AISS8AO4_IOCTL_AO_BUF_FRAME_OVER			BOOR D17
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_BUF_ERROR_CLEAR			0
#define	AISS8AO4_BUF_ERROR_CHECK			(-1)

// For queries the following values are returned.
#define	AISS8AO4_BUF_ERROR_NO				0
#define	AISS8AO4_BUF_ERROR_YES				1

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BUF_THR_LVL			IBTR D0-D18
// AISS8AO4_IOCTL_AO_BUF_THR_LVL			OBTR D0-D18
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0x7FFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BUF_THR_STS			BCR D14, IBTR D19
// AISS8AO4_IOCTL_AO_BUF_THR_STS			BOOR D13, OBTR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO4_BUF_THR_STS_CLEAR			0
#define	AISS8AO4_BUF_THR_STS_SET			1

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BURST_ENABLE			BCR D9
// AISS8AO4_IOCTL_AO_BURST_ENABLE			BOOR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO4_BURST_ENABLE_NO			0
#define	AISS8AO4_BURST_ENABLE_YES			1

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BURST_SIZE				ICR D0-D23
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 0-0xFFFFFF.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_BURST_STATUS			BCR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO4_AI_BURST_STATUS_READY		0
#define	AISS8AO4_AI_BURST_STATUS_BUSY		1

//*****************************************************************************
// AISS8AO4_IOCTL_AI_CHAN_SEL				ICR D24-D31
// AISS8AO4_IOCTL_AO_CHAN_SEL				BOOR D0-D3
//
//	Parameter:	s32*
//		Pass in a bitmap of the channels to enable, or
//		-1 to read the current setting.
//		A valid bitmap is dependent on the number of channels on the
//		corresponding device.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_CLOCK_SRC				BCR D24
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_AI_CLOCK_SRC_EXT			0	// Target Mode
#define	AISS8AO4_AI_CLOCK_SRC_RAG			1	// Initiator Mode, Rate-A Gen

//*****************************************************************************
// AISS8AO4_IOCTL_AI_ENABLE					BCR D12
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AI_ENABLE_NO				0	// Disable the buffer.
#define	AISS8AO4_AI_ENABLE_YES				1	// Enable the buffer.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_MODE					BCR D0-D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_AI_MODE_DIFF				0	// Differential
#define	AISS8AO4_AI_MODE_SINGLE				1	// Single-Ended
#define	AISS8AO4_AI_MODE_ZERO				2	// Zero test
#define	AISS8AO4_AI_MODE_VREF				3	// Vref test
#define	AISS8AO4_AI_MODE_AO_0				4	// Analog Output Channel 0
#define	AISS8AO4_AI_MODE_AO_1				5	// Analog Output Channel 1
#define	AISS8AO4_AI_MODE_AO_2				6	// Analog Output Channel 2
#define	AISS8AO4_AI_MODE_AO_3				7	// Analog Output Channel 3

//*****************************************************************************
// AISS8AO4_IOCTL_AI_RANGE_A				BCR D4-D5
// AISS8AO4_IOCTL_AI_RANGE_B				BCR D6-D7
// AISS8AO4_IOCTL_AO_RANGE					BCR D16-D17
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_RANGE_2_5V					0	// +- 2.5  volts
#define	AISS8AO4_RANGE_5V					1	// +- 5 volts
#define	AISS8AO4_RANGE_10V					2	// +- 10 volts

//*****************************************************************************
// AISS8AO4_IOCTL_AI_SW_CLOCK				BCR D8
// AISS8AO4_IOCTL_AO_SW_CLOCK				BCR D20, BOOR D7
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO4_IOCTL_AI_SW_TRIGGER				BCR D11
// AISS8AO4_IOCTL_AO_SW_TRIGGER				BOOR D20
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO4_IOCTL_AO_ACCESS_MODE			BCR D19
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_ACCESS_MODE_REG			0
#define	AISS8AO4_AO_ACCESS_MODE_FIFO		1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_BUF_MODE				BOOR D8
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_BUF_MODE_OPEN			0
#define	AISS8AO4_AO_BUF_MODE_CLOSED			1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_BUF_STATUS				BOOR D12, D15, D13
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_BUF_STATUS_EMPTY		0	// empty
#define	AISS8AO4_AO_BUF_STATUS_LOW			1	// not empty, threshold clear
#define	AISS8AO4_AO_BUF_STATUS_HIGH			2	// not full, threshold set
#define	AISS8AO4_AO_BUF_STATUS_FULL			3	// full

//*****************************************************************************
// AISS8AO4_IOCTL_AO_BURST_STATUS			BOOR D18
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO4_AO_BURST_STATUS_BUSY		0
#define	AISS8AO4_AO_BURST_STATUS_READY		1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_CLOCK_ENABLE			BOOR D5
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_CLOCK_ENABLE_NO			0	// Disable output clocking
#define	AISS8AO4_AO_CLOCK_ENABLE_YES		1	// Enable output clocking

//*****************************************************************************
// AISS8AO4_IOCTL_AO_CLOCK_READY			BOOR D6
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_CLOCK_READY_NO			0
#define	AISS8AO4_AO_CLOCK_READY_YES			1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_CLOCK_SRC				BOOR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_CLOCK_SRC_EXT			0	// Target Mode
#define	AISS8AO4_AO_CLOCK_SRC_RCG			1	// Initiator Mode, Rate-C Gen

//*****************************************************************************
// AISS8AO4_IOCTL_AO_LOAD_READY				BOOR D10
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_LOAD_READY_NO			0
#define	AISS8AO4_AO_LOAD_READY_YES			1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_LOAD_REQUEST			BOOR D9
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_LOAD_REQUEST_NO			0
#define	AISS8AO4_AO_LOAD_REQUEST_YES		1

//*****************************************************************************
// AISS8AO4_IOCTL_AO_TIMING					BCR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_AO_TIMING_IMMED			0
#define	AISS8AO4_AO_TIMING_SIMUL			1

//*****************************************************************************
// AISS8AO4_IOCTL_DATA_FORMAT				BCR D25
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	AISS8AO4_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// AISS8AO4_IOCTL_DIO_DIR_OUT				DIOPR D8, D24
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_DIO_DIR_OUT_1_IN__0_IN		0
#define	AISS8AO4_DIO_DIR_OUT_1_IN__0_OUT	1
#define	AISS8AO4_DIO_DIR_OUT_1_OUT_0_IN		2
#define	AISS8AO4_DIO_DIR_OUT_1_OUT_0_OUT	3

//*****************************************************************************
// AISS8AO4_IOCTL_DIO_READ					DIOPR D0-D7, D16-D23
//
//	Parameter:	s32*
//		The value returned is in the range of 0 to 0xFFFF.

//*****************************************************************************
// AISS8AO4_IOCTL_DIO_WRITE					DIOPR D0-D7, D16-D23
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 0xFFFF, or
//		-1 to read the current setting.
//		The value returned in the value read.

//*****************************************************************************
// AISS8AO4_IOCTL_GEN_A_ENABLE				BCR D26
// AISS8AO4_IOCTL_GEN_B_ENABLE				BCR D27
// AISS8AO4_IOCTL_GEN_C_ENABLE				BCR D22
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_GEN_ENABLE_NO				0
#define	AISS8AO4_GEN_ENABLE_YES				1

//*****************************************************************************
// AISS8AO4_IOCTL_GEN_A_NDIV				RAGR D0-D23
// AISS8AO4_IOCTL_GEN_B_NDIV				RBGR D0-D23
// AISS8AO4_IOCTL_GEN_C_NDIV				RCGR D0-D23
//
//	Parameter:	s32*
//		Pass in any value in the range of 20 to 0xFFFFFF for A or B.
//		Pass in any value in the range of 40 to 0xFFFFFF for C.
//		Pass in the value -1 to read the current setting.

//*****************************************************************************
// AISS8AO4_IOCTL_IRQ_ENABLE				PSR D0-D14
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_IRQ_AUTOCAL_DONE			0x0001
#define	AISS8AO4_IRQ_AI_THRESH_H2L			0x0002
#define	AISS8AO4_IRQ_AI_THRESH_L2H			0x0004
#define	AISS8AO4_IRQ_AI_BUF_ERROR			0x0008
#define	AISS8AO4_IRQ_AI_BURST_START			0x0010
#define	AISS8AO4_IRQ_AI_BURST_DONE			0x0020
#define	AISS8AO4_IRQ_AI_CLOCK				0x0040
#define	AISS8AO4_IRQ_AO_CLOCK				0x0080
#define	AISS8AO4_IRQ_DIO_0_L2H				0x0100
#define	AISS8AO4_IRQ_AO_THRESH_H2L			0x0200
#define	AISS8AO4_IRQ_AO_THRESH_L2H			0x0400
#define	AISS8AO4_IRQ_AO_LD_RDY_H2L			0x0800
#define	AISS8AO4_IRQ_AO_LD_RDY_L2H			0x1000
#define	AISS8AO4_IRQ_AO_BURST_READY			0x2000
#define	AISS8AO4_IRQ_AO_BUF_ERROR			0x4000
#define	AISS8AO4_IRQ_ALL					0x7FFF

// Retained for backwards compatibility:
#define	AISS8AO4_IRQ_AUTO_CAL_DONE			AISS8AO4_IRQ_AUTOCAL_DONE

//*****************************************************************************
// AISS8AO4_IOCTL_RX_IO_ABORT
// AISS8AO4_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AISS8AO4_IO_ABORT_NO				0
#define	AISS8AO4_IO_ABORT_YES				1

//*****************************************************************************
// AISS8AO4_IOCTL_RX_IO_MODE
// AISS8AO4_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AISS8AO4_IO_MODE_DEFAULT			GSC_IO_MODE_PIO

//*****************************************************************************
// AISS8AO4_IOCTL_RX_IO_OVERFLOW
// AISS8AO4_IOCTL_RX_IO_UNDERFLOW
// AISS8AO4_IOCTL_TX_IO_DATA_OVER
// AISS8AO4_IOCTL_TX_IO_FRAME_OVER
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_IO_ERROR_DEFAULT			AISS8AO4_IO_ERROR_CHECK
#define	AISS8AO4_IO_ERROR_IGNORE			0
#define	AISS8AO4_IO_ERROR_CHECK				1

//*****************************************************************************
// AISS8AO4_IOCTL_RX_IO_TIMEOUT (in seconds)
// AISS8AO4_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AISS8AO4_IO_TIMEOUT_DEFAULT			10
#define	AISS8AO4_IO_TIMEOUT_NO_SLEEP		0
#define	AISS8AO4_IO_TIMEOUT_MIN				0
#define	AISS8AO4_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	AISS8AO4_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AISS8AO4_IOCTL_TRIGGER_SRC				BCR D21
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO4_TRIGGER_SRC_EXT			0	// Target Mode
#define	AISS8AO4_TRIGGER_SRC_RBG			1	// Initiator Mode, Rate-B Gen

//*****************************************************************************
// AISS8AO4_IOCTL_WAIT_EVENT				all fields must be valid
// AISS8AO4_IOCTL_WAIT_CANCEL				fields need not be valid
// AISS8AO4_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AISS8AO4_WAIT_GSC_AUTOCAL_DONE		AISS8AO4_IRQ_AUTOCAL_DONE
#define	AISS8AO4_WAIT_GSC_AI_THRESH_H2L		AISS8AO4_IRQ_AI_THRESH_H2L
#define	AISS8AO4_WAIT_GSC_AI_THRESH_L2H		AISS8AO4_IRQ_AI_THRESH_L2H
#define	AISS8AO4_WAIT_GSC_AI_BUF_ERROR		AISS8AO4_IRQ_AI_BUF_ERROR
#define	AISS8AO4_WAIT_GSC_AI_BURST_START	AISS8AO4_IRQ_AI_BURST_START
#define	AISS8AO4_WAIT_GSC_AI_BURST_DONE		AISS8AO4_IRQ_AI_BURST_DONE
#define	AISS8AO4_WAIT_GSC_AI_CLOCK			AISS8AO4_IRQ_AI_CLOCK
#define	AISS8AO4_WAIT_GSC_AO_CLOCK			AISS8AO4_IRQ_AO_CLOCK
#define	AISS8AO4_WAIT_GSC_DIO_0_L2H			AISS8AO4_IRQ_DIO_0_L2H
#define	AISS8AO4_WAIT_GSC_AO_THRESH_H2L		AISS8AO4_IRQ_AO_THRESH_H2L
#define	AISS8AO4_WAIT_GSC_AO_THRESH_L2H		AISS8AO4_IRQ_AO_THRESH_L2H
#define	AISS8AO4_WAIT_GSC_AO_LD_RDY_H2L		AISS8AO4_IRQ_AO_LD_RDY_H2L
#define	AISS8AO4_WAIT_GSC_AO_LD_RDY_L2H		AISS8AO4_IRQ_AO_LD_RDY_L2H
#define	AISS8AO4_WAIT_GSC_AO_BURST_READY	AISS8AO4_IRQ_AO_BURST_READY
#define	AISS8AO4_WAIT_GSC_AO_BUF_ERROR		AISS8AO4_IRQ_AO_BUF_ERROR
#define	AISS8AO4_WAIT_GSC_ALL				AISS8AO4_IRQ_ALL
// gsc_wait_t.alt flags
#define	AISS8AO4_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	AISS8AO4_WAIT_IO_RX_ABORT			0x0001
#define	AISS8AO4_WAIT_IO_RX_DONE			0x0002
#define	AISS8AO4_WAIT_IO_RX_ERROR			0x0004
#define	AISS8AO4_WAIT_IO_RX_TIMEOUT			0x0008

#define	AISS8AO4_WAIT_IO_TX_ABORT			0x0010
#define	AISS8AO4_WAIT_IO_TX_DONE			0x0020
#define	AISS8AO4_WAIT_IO_TX_ERROR			0x0040
#define	AISS8AO4_WAIT_IO_TX_TIMEOUT			0x0080

#define	AISS8AO4_WAIT_IO_ALL				0x00FF

// Retained for backwards compatibility.
#define	AISS8AO4_WAIT_GSC_AUTO_CAL_DONE		AISS8AO4_WAIT_GSC_AUTOCAL_DONE

//*****************************************************************************
// AISS8AO4_IOCTL_BURST_SYNC				BOOR D21
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AISS8AO4_BURST_SYNC_DISABLE			0
#define	AISS8AO4_BURST_SYNC_ENABLE			1



#endif
