// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/include/16aiss8ao4_utils.h $
// $Rev: 54004 $
// $Date: 2023-12-12 08:57:19 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Utilities: header file

#ifndef	__16AISS8AO4_UTILS_H__
#define	__16AISS8AO4_UTILS_H__

#include "16aiss8ao4_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	aiss8ao4_close_util			(int fd, int index, int verbose);
int aiss8ao4_init_util			(int verbose);
int aiss8ao4_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	aiss8ao4_open_util			(int device, int share, int index, int verbose, int* fd);
int	aiss8ao4_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);
int	aiss8ao4_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent);

// IOCTL utility services

int	aiss8ao4_ai_buf_clear		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AI_BUF_CLEAR
int	aiss8ao4_ai_buf_level		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AI_BUF_LEVEL
int	aiss8ao4_ai_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_BUF_OVERFLOW
int	aiss8ao4_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_BUF_THR_LVL
int	aiss8ao4_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AI_BUF_THR_STS
int	aiss8ao4_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_BUF_UNDERFLOW
int	aiss8ao4_ai_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_BURST_ENABLE
int	aiss8ao4_ai_burst_size		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_BURST_SIZE
int	aiss8ao4_ai_burst_status	(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AI_BURST_STATUS
int	aiss8ao4_ai_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_CHAN_SEL
int	aiss8ao4_ai_clock_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_CLOCK_SRC
int	aiss8ao4_ai_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_ENABLE
int	aiss8ao4_ai_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_MODE
int	aiss8ao4_ai_range_a			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_RANGE_A
int	aiss8ao4_ai_range_b			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AI_RANGE_B
int	aiss8ao4_ai_sw_clock		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AI_SW_CLOCK
int	aiss8ao4_ai_sw_trigger		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AI_SW_TRIGGER
int	aiss8ao4_ao_access_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_ACCESS_MODE
int	aiss8ao4_ao_buf_clear		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AO_BUF_CLEAR
int	aiss8ao4_ao_buf_data_over	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BUF_DATA_OVER
int	aiss8ao4_ao_buf_frame_over	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BUF_FRAME_OVER
int	aiss8ao4_ao_buf_level		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BUF_LEVEL
int	aiss8ao4_ao_buf_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BUF_MODE
int	aiss8ao4_ao_buf_status		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_BUF_STATUS
int	aiss8ao4_ao_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BUF_THR_LVL
int	aiss8ao4_ao_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_BUF_THR_STS
int	aiss8ao4_ao_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_BURST_ENABLE
int	aiss8ao4_ao_burst_status	(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_BURST_STATUS
int	aiss8ao4_ao_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_CHAN_SEL
int	aiss8ao4_ao_clock_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_CLOCK_ENABLE
int	aiss8ao4_ao_clock_ready		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_CLOCK_READY
int	aiss8ao4_ao_clock_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_CLOCK_SRC
int	aiss8ao4_ao_load_ready		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_LOAD_READY
int	aiss8ao4_ao_load_request	(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AO_LOAD_REQUEST
int	aiss8ao4_ao_range			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_RANGE
int	aiss8ao4_ao_sw_clock		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AO_SW_CLOCK
int	aiss8ao4_ao_sw_trigger		(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AO_SW_TRIGGER
int	aiss8ao4_ao_timing			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_AO_TIMING
int	aiss8ao4_autocal			(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AUTOCAL
int	aiss8ao4_autocal_ai			(int fd, int index, int verbose);								// AISS8AO4_IOCTL_AUTOCAL_AI
int	aiss8ao4_autocal_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_AUTOCAL_STATUS
int	aiss8ao4_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_DATA_FORMAT
int	aiss8ao4_burst_sync			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_BURST_SYNC
int	aiss8ao4_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_DIO_DIR_OUT
int	aiss8ao4_dio_read			(int fd, int index, int verbose, s32* get);						// AISS8AO4_IOCTL_DIO_READ
int	aiss8ao4_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_DIO_WRITE
int	aiss8ao4_gen_a_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_A_ENABLE
int	aiss8ao4_gen_a_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_A_NDIV
int	aiss8ao4_gen_b_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_B_ENABLE
int	aiss8ao4_gen_b_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_B_NDIV
int	aiss8ao4_gen_c_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_C_ENABLE
int	aiss8ao4_gen_c_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_GEN_C_NDIV
int	aiss8ao4_initialize			(int fd, int index, int verbose);								// AISS8AO4_IOCTL_INITIALIZE
int	aiss8ao4_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_IRQ_ENABLE
int	aiss8ao4_query				(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_QUERY
int	aiss8ao4_reg_mod			(int fd, int index, int verbose, u32 reg, u32 set, u32 mask);	// AISS8AO4_IOCTL_REG_MOD
int	aiss8ao4_reg_read			(int fd, int index, int verbose, u32 reg, u32* get);			// AISS8AO4_IOCTL_REG_READ
int	aiss8ao4_reg_write			(int fd, int index, int verbose, u32 reg, u32 set);				// AISS8AO4_IOCTL_REG_WRITE
int	aiss8ao4_rx_io_abort		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_RX_IO_ABORT
int	aiss8ao4_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_RX_IO_MODE
int	aiss8ao4_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_RX_IO_OVERFLOW
int	aiss8ao4_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_RX_IO_TIMEOUT
int	aiss8ao4_rx_io_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_RX_IO_UNDERFLOW
int	aiss8ao4_trigger_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TRIGGER_SRC
int	aiss8ao4_tx_io_abort		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TX_IO_ABORT
int	aiss8ao4_tx_io_data_over	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TX_IO_DATA_OVER
int	aiss8ao4_tx_io_frame_over	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TX_IO_FRAME_OVER
int	aiss8ao4_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TX_IO_MODE
int	aiss8ao4_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO4_IOCTL_TX_IO_TIMEOUT
int	aiss8ao4_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO4_IOCTL_WAIT_CANCEL
int	aiss8ao4_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO4_IOCTL_WAIT_EVENT
int	aiss8ao4_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO4_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	aiss8ao4_config_ai			(int fd, int index, int verbose, s32 fsamp);
int	aiss8ao4_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	aiss8ao4_fsamp_ai_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	aiss8ao4_fsamp_ai_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss8ao4_fsamp_ai_report_all(int fd, int index, int verbose, s32* fsamp);
int	aiss8ao4_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	aiss8ao4_fsamp_ao_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss8ao4_fsamp_ao_report_all(int fd, int index, int verbose, s32* fsamp);
int	aiss8ao4_id_device			(int fd, int index, int verbose);

int	aiss8ao4_count_boards		(int verbose, s32* get);
int	aiss8ao4_reg_list			(int fd, int detail);

const gsc_reg_def_t*			aiss8ao4_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*			aiss8ao4_reg_get_def_index	(int index);
const char*						aiss8ao4_reg_get_desc		(u32 reg);
const char*						aiss8ao4_reg_get_name		(u32 reg);

// Retained for backwards compatibility:
int	aiss8ao4_auto_cal_sts		(int fd, int index, int verbose, s32* get);
int	aiss8ao4_auto_calibrate		(int fd, int index, int verbose);
int	aiss8ao4_auto_calibrate_ai	(int fd, int index, int verbose);


#endif
