// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/samples/aout/main.h $
// $Rev: 54016 $
// $Date: 2023-12-12 09:05:30 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <limits.h>
#include <math.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16aiss8ao4_main.h"
#include "file.h"



// macros *********************************************************************

#define	DATA_FILE				"data.txt"
#define	LOG_FILE				"log.txt"
#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	chan_qty;		// Generate output on # channels.
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	decimal;		// Save teh data in decimal format?
	s32	empty_qty;		// Stop if the buffer runs empty # times (required -ml).
	s32	indefinate;		// Write data without limit until there is a problem.
	s32	index;			// device index
	s32	log_prefill;	// Log the prefill activity?
	s32	log_qty;		// Stop after logging # entries (requires -ml).
	s32	minute_limit;	// for continuous testing
	s32	minutes;		// Output data for this long.
	s32	monitor;		// Monitor and log timing and performance.
	int	qty;			// Number of devices detected.
	s32	reg_dump;		// When us_stop or empty_qty kick in, generate a register dump.
	s32	save;			// Save the pattern data to a file.
	s32	save_force;		// Force save even if there are errors.
	s32	scan_limit;		// Limit output to # scans per write call
	s32	seconds;		// Output data for this long.
	s32	test_limit;		// for continuous testing
	s32	us_stop;		// Stop if write take # us or less

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	fsamp;
	s32	io_mode;
} args_t;



// prototypes *****************************************************************

int		perform_tests(const args_t* args);



#endif
