// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/samples/id/perform.c $
// $Rev: 54010 $
// $Date: 2023-12-12 09:01:55 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single-Ended, Zero Test, +Vref Test, Chan 0/1/2/3 Loopback\n");
}



//*****************************************************************************
static void _voltage_ranges(void)
{
	gsc_label("Input Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V\n");

	gsc_label("Output Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate Generator(s), External, Software\n");
}



//*****************************************************************************
static void _sampling_modes(void)
{
	gsc_label("Input Sampling Modes");
	printf("Continuous, Burst\n");

	gsc_label("Output Sampling Modes");
	printf("Continuous, Burst\n");

	gsc_label("Output Timing Modes");
	printf("Immediate, Synchronous\n");
}



//*****************************************************************************
static void _digital_io(void)
{
	gsc_label("Digital I/O");
	printf("16 Bi-Directional Signals (2 ports, 8-bits each)\n");
}



//*****************************************************************************
static int _id_device_reg(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= aiss8ao4_reg_get_def_id(AISS8AO4_GSC_ACR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, aiss8ao4_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. aiss8ao4_reg_get_def_id, AISS8AO4_GSC_ACR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= aiss8ao4_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_input_modes();
	_voltage_ranges();
	_clocking_sources();
	_sampling_modes();
	_digital_io();

	for (i = 0; i < AISS8AO4_IOCTL_QUERY_LAST; i++)
		errs	+= aiss8ao4_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


