// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/samples/savedata/main.h $
// $Rev: 54015 $
// $Date: 2023-12-12 09:05:08 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16aiss8ao4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))
#define	CHAN_TAG_EXCLUDE		1
#define	CHAN_TAG_ONLY			2



// data types *****************************************************************

typedef struct
{
	// Application Settings

	int		argc;			// record in data file
	char**	argv;			// record in data file
	s32		chan_tag;		// Channel tag processing.
	s32		continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32		decimal;		// Save data in decimal format? Default is hex.
	s32		force_save;		// Save data even if there are errors?
	s32		fsamp;			// Desired sample rate.
	s32		index;			// device index
	s32		minute_limit;	// for continuous testing
	int		qty;			// Number of devices detected.
	s32		repeat;			// repeat data retrieval this many times
	s32		test_limit;		// for continuous testing

	int		fd;				// File descriptor for device to access.

	// Device Settings

	s32		ai_mode;		// Analog Input Mode
	s32		io_mode;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
