// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/samples/signals/perform.c $
// $Rev: 54013 $
// $Date: 2023-12-12 09:03:36 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	char	buf[80];
	int		errs	= 0;

	errs	+= aiss8ao4_initialize		(args->fd, -1, 1);

	//===============================================================
	gsc_label("Input Clock");
	printf("\n");
	gsc_label_level_inc();

	errs	+= aiss8ao4_ai_clock_src	(args->fd, -1, 1, AISS8AO4_AI_CLOCK_SRC_RAG, NULL);
	errs	+= aiss8ao4_gen_a_ndiv		(args->fd, -1, 1, 2688, NULL);
	errs	+= aiss8ao4_gen_a_enable	(args->fd, -1, 1, AISS8AO4_GEN_ENABLE_YES, NULL);
	errs	+= aiss8ao4_ai_enable		(args->fd, -1, 1, AISS8AO4_AI_ENABLE_YES, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Output Clock");
	printf("\n");
	gsc_label_level_inc();

	errs	+= aiss8ao4_ao_access_mode	(args->fd, -1, 1, AISS8AO4_AO_ACCESS_MODE_REG, NULL);
	errs	+= aiss8ao4_ao_clock_src	(args->fd, -1, 1, AISS8AO4_AO_CLOCK_SRC_RCG, NULL);
	errs	+= aiss8ao4_gen_c_ndiv		(args->fd, -1, 1, 4032, NULL);
	errs	+= aiss8ao4_gen_c_enable	(args->fd, -1, 1, AISS8AO4_GEN_ENABLE_YES, NULL);
	errs	+= aiss8ao4_ao_clock_enable	(args->fd, -1, 1, AISS8AO4_AO_CLOCK_ENABLE_YES, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Trigger");
	printf("\n");
	gsc_label_level_inc();

	errs	+= aiss8ao4_trigger_src		(args->fd, -1, 1, AISS8AO4_TRIGGER_SRC_RBG, NULL);
	errs	+= aiss8ao4_ao_burst_enable	(args->fd, -1, 1, AISS8AO4_BURST_ENABLE_YES, NULL);
	errs	+= aiss8ao4_gen_b_ndiv		(args->fd, -1, 1, 20160, NULL);
	errs	+= aiss8ao4_gen_b_enable	(args->fd, -1, 1, AISS8AO4_GEN_ENABLE_YES, NULL);

	gsc_label_level_dec();

	//===============================================================
	sprintf(buf, "Waiting (%ld sec%s)", (long) args->seconds, (args->seconds == 1) ? "" : "s");
	gsc_label(buf);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	return(errs);
}



