// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/utils/util_ai_buf_level.c $
// $Rev: 43450 $
// $Date: 2018-08-29 15:56:40 -0500 (Wed, 29 Aug 2018) $

// 16AISS8AO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss8ao4_ai_buf_level
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS8AO4_IOCTL_AI_BUF_LEVEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aiss8ao4_ai_buf_level(int fd, int index, int verbose, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;
	s32		set;

	if (verbose)
		gsc_label_index("AI Buffer Fill Level", index);

	ret		= aiss8ao4_ioctl(fd, AISS8AO4_IOCTL_AI_BUF_LEVEL, &set);
	errs	= ret ? 1 : 0;
	sprintf(buf, "%ld samples\n", (long) set);

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


