// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/utils/util_ao_buf_status.c $
// $Rev: 43450 $
// $Date: 2018-08-29 15:56:40 -0500 (Wed, 29 Aug 2018) $

// 16AISS8AO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss8ao4_ao_buf_status
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS8AO4_IOCTL_AO_BUF_STATUS service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aiss8ao4_ao_buf_status(int fd, int index, int verbose, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	int			ret;
	s32			set;

	if (verbose)
		gsc_label_index("AO Buffer Status", index);

	ret		= aiss8ao4_ioctl(fd, AISS8AO4_IOCTL_AO_BUF_STATUS, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case AISS8AO4_AO_BUF_STATUS_EMPTY:

			ptr	= "Empty";
			break;

		case AISS8AO4_AO_BUF_STATUS_LOW:

			ptr	= "Low";
			break;

		case AISS8AO4_AO_BUF_STATUS_HIGH:

			ptr	= "High";
			break;

		case AISS8AO4_AO_BUF_STATUS_FULL:

			ptr	= "Full";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


