// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS8AO4/16aiss8ao4_Linux_3.x.x.x_gsc_dn/utils/util_reg.c $
// $Rev: 54006 $
// $Date: 2023-12-12 08:58:57 -0600 (Tue, 12 Dec 2023) $

// 16AISS8AO4: Utilities: source file

#include "main.h"



// macros *********************************************************************

#define	_GSC_REG(a)						"GSC " #a, AISS8AO4_GSC_##a, 0, 0
#define	SHOW_FIELD(b,e,eol,l,d)			gsc_reg_field_show(width+10,28, value,(b),(e),(eol),(l),(d))



//*****************************************************************************
static int _bcr_retail(int fd, int supported, u32 value, int width)
{
	static const char*	_aim[]	=
	{
		"Differential",
		"Single-Ended",
		"Zero Test",
		"Vref Test",
		"Output Channel 0 Loopback",
		"Output Channel 1 Loopback",
		"Output Channel 2 Loopback",
		"Output Channel 3 Loopback"
	};

	static const char*	_range[]	=
	{
		"+-2.5 Volts",
		"+-5 Volts",
		"+-10 Volts",
		"RESERVED"
	};

	static const char*	_disable[]	= { "Disabled",			"Enabled"		};
	static const char*	_clear[]	= { "Clear",			"Set"			};
	static const char*	_fail[]		= { "Fail",				"Pass"			};
	static const char*	_idle[]		= { "Idle",				"Active"		};
	static const char*	_immed[]	= { "Immediate",		"Simultaneous"	};
	static const char*	_no[]		= { "No",				"Yes"			};
	static const char*	_reg[]		= { "Register",			"Buffer (FIFO)"	};
	static const char*	_target[]	= { "Target",			"Initiator"		};
	static const char*	_twos[]		= { "Twos Compliment",	"Offset Binary"	};

	SHOW_FIELD( 2,  0, 1, _aim,		"Input Mode"				);
	SHOW_FIELD( 3,  3, 1, _idle,	"AI Autocalibration"		);
	SHOW_FIELD( 5,  4, 1, _range,	"AI Range A"				);
	SHOW_FIELD( 7,  6, 1, _range,	"AI Range B"				);
	SHOW_FIELD( 8,  8, 1, _idle,	"AI Software Clock"			);
	SHOW_FIELD( 9,  9, 1, _disable,	"AI Bursting"				);
	SHOW_FIELD(10, 10, 1, _idle,	"AI Burst Status"			);
	SHOW_FIELD(11, 11, 1, _idle,	"AI Software Trigger"		);
	SHOW_FIELD(12, 12, 1, _disable,	"AI Buffer"					);
	SHOW_FIELD(13, 13, 1, _idle,	"AI Buffer Clear"			);
	SHOW_FIELD(14, 14, 1, _clear,	"AI Buffer Threshold Flag"	);
	SHOW_FIELD(15, 15, 1, _no,		"AI Buffer Overflow"		);
	SHOW_FIELD(17, 16, 1, _range,	"AO Range"					);
	SHOW_FIELD(18, 18, 1, _immed,	"AO Timing Mode"			);
	SHOW_FIELD(19, 19, 1, _reg,		"AO Access Mode"			);
	SHOW_FIELD(20, 20, 1, _idle,	"AO Software Clock"			);
	SHOW_FIELD(21, 21, 1, _target,	"Trigger Mode"				);
	SHOW_FIELD(22, 22, 1, _disable,	"Rate-C Generator"			);
	SHOW_FIELD(23, 23, 1, _no,		"AI Buffer Underflow"		);
	SHOW_FIELD(24, 24, 1, _target,	"AI Clock Mode"				);
	SHOW_FIELD(25, 25, 1, _twos,	"Data Format"				);
	SHOW_FIELD(26, 26, 1, _disable,	"Rate-A Generator"			);
	SHOW_FIELD(27, 27, 1, _disable,	"Rate-B Generator"			);
	SHOW_FIELD(28, 28, 1, _idle,	"Autocalibration"			);
	SHOW_FIELD(29, 29, 1, _fail,	"Autocalibration Status"	);
	SHOW_FIELD(30, 30, 1, _no,		"DMDMA Channel Swap"		);
	SHOW_FIELD(31, 31, 1, _idle,	"Initialize"				);
	return(0);
}



//*****************************************************************************
static int _diopr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_input[]	= { "Input",	"Output"	};

	SHOW_FIELD( 7,  0, 1, NULL,		"DIO Byte 0"				);
	SHOW_FIELD( 8,  8, 1, _input,	"DIO Byte 0 Direction"		);
	SHOW_FIELD(15,  9, 1, NULL,		"Reserved"					);
	SHOW_FIELD(23, 16, 1, NULL,		"DIO Byte 1"				);
	SHOW_FIELD(24, 24, 1, _input,	"DIO Byte 1 Direction"		);
	SHOW_FIELD(31, 25, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _ocdr_detail(int fd, int supported, u32 value, int width)
{
	SHOW_FIELD(15,  0, 1, NULL,		"Data"						);
	SHOW_FIELD(31, 16, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _ibdr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_no[]	= { "No",	"Yes"	};

	SHOW_FIELD(15,  0, 1, NULL,		"Data"						);
	SHOW_FIELD(16, 16, 1, _no,		"First Channel Tag"			);
	SHOW_FIELD(17, 17, 1, _no,		"End Of Burst"				);
	SHOW_FIELD(31, 18, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _rxgr_detail(int fd, int supported, u32 value, int width)
{
	SHOW_FIELD(23,  0, 1, NULL,		"Ndiv"						);
	SHOW_FIELD(31, 24, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _icr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_disable[]	= { "Disabled",	"Enabled"	};

	SHOW_FIELD(23,  0, 1, NULL,		"AI Burst Block Size"		);
	SHOW_FIELD(24, 24, 1, _disable,	"AI Channel 0"				);
	SHOW_FIELD(25, 25, 1, _disable,	"AI Channel 1"				);
	SHOW_FIELD(26, 26, 1, _disable,	"AI Channel 2"				);
	SHOW_FIELD(27, 27, 1, _disable,	"AI Channel 3"				);
	SHOW_FIELD(28, 28, 1, _disable,	"AI Channel 4"				);
	SHOW_FIELD(29, 29, 1, _disable,	"AI Channel 5"				);
	SHOW_FIELD(30, 30, 1, _disable,	"AI Channel 6"				);
	SHOW_FIELD(31, 31, 1, _disable,	"AI Channel 7"				);
	return(0);
}



//*****************************************************************************
static int _xbsr_detail(int fd, int supported, u32 value, int width)
{
	SHOW_FIELD(18,  0, 1, NULL,		"Fill Level"				);
	SHOW_FIELD(31, 19, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _xbtr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_clear[]	= { "Clear",	"Set"	};

	SHOW_FIELD(18,  0, 1, NULL,		"Threshold Level"			);
	SHOW_FIELD(19, 19, 1, _clear,	"Threshold Status"			);
	SHOW_FIELD(31, 20, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _psr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_idle[]		= { "Idle",		"Active"	};
	static const char*	_disable[]	= { "Disabled",	"Enabled"	};

	SHOW_FIELD( 0,  0, 1, _disable,	"Autocal Completed"			);
	SHOW_FIELD( 1,  1, 1, _disable,	"AI Buffer Threshold H->L"	);
	SHOW_FIELD( 2,  2, 1, _disable,	"AI Buffer Threshold L->H"	);
	SHOW_FIELD( 3,  3, 1, _disable,	"AI Buffer Over/Under Err"	);
	SHOW_FIELD( 4,  4, 1, _disable,	"AI Burst Strt (STS L->H)"	);
	SHOW_FIELD( 5,  5, 1, _disable,	"AI Burst Done (STS H->L)"	);
	SHOW_FIELD( 6,  6, 1, _disable,	"AI Clock"					);
	SHOW_FIELD( 7,  7, 1, _disable,	"AO Clock"					);
	SHOW_FIELD( 8,  8, 1, _disable,	"DIO 0 L->H"				);
	SHOW_FIELD( 9,  9, 1, _disable,	"AO Buffer Threshold H->L"	);
	SHOW_FIELD(10, 10, 1, _disable,	"AO Buffer Threshold L->H"	);
	SHOW_FIELD(11, 11, 1, _disable,	"AO Load Ready H->L"		);
	SHOW_FIELD(12, 12, 1, _disable,	"AO Load Ready L->H"		);
	SHOW_FIELD(13, 13, 1, _disable,	"AO Burst Ready"			);
	SHOW_FIELD(14, 14, 1, _disable,	"AO Buffer Data/Frame Err"	);
	SHOW_FIELD(15, 15, 1, NULL,		"Reserved"					);
	SHOW_FIELD(16, 16, 1, _idle,	"Autocal Completed"			);
	SHOW_FIELD(17, 17, 1, _idle,	"AI Buffer Threshold H->L"	);
	SHOW_FIELD(18, 18, 1, _idle,	"AI Buffer Threshold L->H"	);
	SHOW_FIELD(19, 19, 1, _idle,	"AI Buffer Over/Under Err"	);
	SHOW_FIELD(20, 20, 1, _idle,	"AI Burst Strt (STS L->H)"	);
	SHOW_FIELD(21, 21, 1, _idle,	"AI Burst Done (STS H->L)"	);
	SHOW_FIELD(22, 22, 1, _idle,	"AI Clock"					);
	SHOW_FIELD(23, 23, 1, _idle,	"AO Clock"					);
	SHOW_FIELD(24, 24, 1, _idle,	"DIO 0 L->H"				);
	SHOW_FIELD(25, 25, 1, _idle,	"AO Buffer Threshold H->L"	);
	SHOW_FIELD(26, 26, 1, _idle,	"AO Buffer Threshold L->H"	);
	SHOW_FIELD(27, 27, 1, _idle,	"AO Load Ready H->L"		);
	SHOW_FIELD(28, 28, 1, _idle,	"AO Load Ready L->H"		);
	SHOW_FIELD(29, 29, 1, _idle,	"AO Burst Ready"			);
	SHOW_FIELD(30, 30, 1, _idle,	"AO Buffer Data/Frame Err"	);
	SHOW_FIELD(31, 31, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _acr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_master[]	=
	{
		"40.320MHz",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_4_0[]	= { "4",		"None"	};
	static const char*	_8_4[]	= { "8",		"4"		};
	static const char*	_std[]	= { "Standard",	"SMA"	};

	u32	v;

	SHOW_FIELD(11,  0, 0, NULL,		"Firmware Version"	);
	v	= GSC_FIELD_DECODE(value, 11, 0);
	printf("%03lX\n", (long) v);

	SHOW_FIELD(15, 12, 1, NULL,		"Reserved"					);
	SHOW_FIELD(16, 16, 1, _8_4,		"Input Channels"			);
	SHOW_FIELD(17, 17, 1, _4_0,		"Output Channels"			);
	SHOW_FIELD(19, 18, 1, _master,	"Master Clock"				);
	SHOW_FIELD(20, 20, 1, NULL,		"Reserved"					);
	SHOW_FIELD(21, 21, 1, _std,		"System I/O Configuration"	);
	SHOW_FIELD(31, 22, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _boor_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_clear[]	= { "Clear",		"Set"		};
	static const char*	_disable[]	= { "Disabled",		"Enabled"	};
	static const char*	_idle[]		= { "Idle",			"Active"	};
	static const char*	_no[]		= { "No",			"Yes"		};
	static const char*	_not_rea[]	= { "Not Ready",	"Ready"		};
	static const char*	_open[]		= { "Open",			"Closed"	};
	static const char*	_target[]	= { "Target",		"Initiator"	};

	SHOW_FIELD( 0,  0, 1, _disable,	"AO Channel 0"				);
	SHOW_FIELD( 1,  1, 1, _disable,	"AO Channel 1"				);
	SHOW_FIELD( 2,  2, 1, _disable,	"AO Channel 2"				);
	SHOW_FIELD( 3,  3, 1, _disable,	"AO Channel 3"				);
	SHOW_FIELD( 4,  4, 1, _target,	"AO Clock Mode"				);
	SHOW_FIELD( 5,  5, 1, _disable,	"AO Clocking"				);
	SHOW_FIELD( 6,  6, 1, _not_rea,	"AO Clock Status"			);
	SHOW_FIELD( 7,  7, 1, _idle,	"AO Software Clock"			);
	SHOW_FIELD( 8,  8, 1, _open,	"AO Buffer Mode"			);
	SHOW_FIELD( 9,  9, 1, _idle,	"AO Load Request"			);
	SHOW_FIELD(10, 10, 1, _not_rea,	"AO Load Status"			);
	SHOW_FIELD(11, 11, 1, _idle,	"AO Buffer Clear"			);
	SHOW_FIELD(12, 12, 1, _no,		"AO Buffer Empty"			);
	SHOW_FIELD(13, 13, 1, _clear,	"AO Buffer Threshold Flag"	);
	SHOW_FIELD(14, 14, 1, NULL,		"Reserved"					);
	SHOW_FIELD(15, 15, 1, _no,		"AO Buffer Full"			);
	SHOW_FIELD(16, 16, 1, _no,		"AO Buffer Data Overflow"	);
	SHOW_FIELD(17, 17, 1, _no,		"AO Buffer Frame Overflow"	);
	SHOW_FIELD(18, 18, 1, _not_rea,	"AO Burst Status"			);
	SHOW_FIELD(19, 19, 1, _disable,	"AO Bursting"				);
	SHOW_FIELD(20, 20, 1, _idle,	"AO Software Trigger"		);
	SHOW_FIELD(31, 21, 1, NULL,		"Reserved"					);
	return(0);
}



//*****************************************************************************
static int _obdr_detail(int fd, int supported, u32 value, int width)
{
	static const char*	_no[]	= { "No",	"Yes"	};

	SHOW_FIELD(15,  0, 1, NULL,		"Data"						);
	SHOW_FIELD(16, 16, 1, _no,		"EOF Flag"					);
	SHOW_FIELD(31, 17, 1, NULL,		"Reserved"					);
	return(0);
}



// variables ******************************************************************

static gsc_reg_def_t	_gsc[]	=
{
	{ _GSC_REG(BCR),		0,	_bcr_retail,	"Board Control Register"				},
	{ _GSC_REG(DIOPR),		0,	_diopr_detail,	"Digital I/O Port Register"				},
	{ _GSC_REG(OC0DR),		0,	_ocdr_detail,	"Output Channel 0 Data Register"		},
	{ _GSC_REG(OC1DR),		0,	_ocdr_detail,	"Output Channel 1 Data Register"		},
	{ _GSC_REG(OC2DR),		0,	_ocdr_detail,	"Output Channel 2 Data Register"		},
	{ _GSC_REG(OC3DR),		0,	_ocdr_detail,	"Output Channel 3 Data Register"		},
	{ _GSC_REG(IBDR),		0,	_ibdr_detail,	"Input Buffer Data Register"			},
	{ _GSC_REG(RAGR),		0,	_rxgr_detail,	"Rate-A Generator Register"				},
	{ _GSC_REG(RBGR),		0,	_rxgr_detail,	"Rate-B Generator Register"				},
	{ _GSC_REG(ICR),		0,	_icr_detail,	"Input Configuration Register"			},
	{ _GSC_REG(IBSR),		0,	_xbsr_detail,	"Input Buffer Size Register"			},
	{ _GSC_REG(IBTR),		0,	_xbtr_detail,	"Input Buffer Threshold Register"		},
	{ _GSC_REG(PSR),		0,	_psr_detail,	"Primary Status Register"				},
	{ _GSC_REG(ACR),		0,	_acr_detail,	"Assembly Configuration Register"		},
	{ _GSC_REG(AVR),		0,	NULL,			"Autocal Values Register"				},
	{ _GSC_REG(BOOR),		0,	_boor_detail,	"Buffered Output Operations Register"	},
	{ _GSC_REG(OBTR),		0,	_xbtr_detail,	"Output Buffer Threshold Register"		},
	{ _GSC_REG(OBSR),		0,	_xbsr_detail,	"Output Buffer Size Register"			},
	{ _GSC_REG(OBDR),		0,	_obdr_detail,	"Output Buffer Data Register"			},
	{ _GSC_REG(RCGR),		0,	_rxgr_detail,	"Rate-C Generator Register"				},
	{ _GSC_REG(AU0R),		0,	NULL,			"Auxiliary User 0 Register"				},
	{ _GSC_REG(AU1R),		0,	NULL,			"Auxiliary User 1 Register"				},
	{ _GSC_REG(AU2R),		0,	NULL,			"Auxiliary User 2 Register"				},
	{ _GSC_REG(AU3R),		0,	NULL,			"Auxiliary User 3 Register"				},

	{ NULL, 0, 0, 0, 0,		NULL	}
};



//*****************************************************************************
static const gsc_reg_def_t* _find_reg(u32 reg, const gsc_reg_def_t* list)
{
	const gsc_reg_def_t*	def	= NULL;
	int						i;

	for (i = 0; list[i].name; i++)
	{
		if (reg == list[i].reg)
		{
			def	= &list[i];
			break;
		}
	}

	return(def);
}



/******************************************************************************
*
*	Function:	aiss8ao4_reg_get_def_id
*
*	Purpose:
*
*		Retrieve the register definition structure given the register id.
*
*	Arguments:
*
*		reg		The id of the register to access.
*
*	Returned:
*
*		NULL	The register id wasn't found.
*		else	A pointer to the register definition.
*
******************************************************************************/

const gsc_reg_def_t* aiss8ao4_reg_get_def_id(u32 reg)
{
	const gsc_reg_def_t*	def;

	def	= _find_reg(reg, _gsc);
	return(def);
}



/******************************************************************************
*
*	Function:	aiss8ao4_reg_get_def_index
*
*	Purpose:
*
*		Retrieve the register definition structure based on an index.
*
*	Arguments:
*
*		index	The index of the register to access.
*
*	Returned:
*
*		NULL	The index doesn't correspond to a known register.
*		else	A pointer to the register definition.
*
******************************************************************************/

const gsc_reg_def_t* aiss8ao4_reg_get_def_index(int index)
{
	const gsc_reg_def_t*	def;

	if (index < 0)
		def	= NULL;
	else if (index >= (SIZEOF_ARRAY(_gsc) - 1))
		def	= NULL;
	else
		def	= &_gsc[index];

	return(def);
}



/******************************************************************************
*
*	Function:	aiss8ao4_reg_get_desc
*
*	Purpose:
*
*		Retrieve the description of the specified register.
*
*	Arguments:
*
*		reg		The register whose description is desired.
*
*	Returned:
*
*		!NULL	The register's name.
*
******************************************************************************/

const char* aiss8ao4_reg_get_desc(u32 reg)
{
	const gsc_reg_def_t*	def;
	const char*				desc;

	def	= _find_reg(reg, _gsc);

	if (def)
		desc	= def->desc;
	else
		desc	= "UNKNOWN";

	return(desc);
}



/******************************************************************************
*
*	Function:	aiss8ao4_reg_get_name
*
*	Purpose:
*
*		Retrieve the name of the specified register.
*
*	Arguments:
*
*		reg		The register whose name is desired.
*
*	Returned:
*
*		!NULL	The register's name.
*
******************************************************************************/

const char* aiss8ao4_reg_get_name(u32 reg)
{
	const gsc_reg_def_t*	def;
	const char*				name;

	def	= _find_reg(reg, _gsc);

	if (def)
		name	= def->name;
	else
		name	= "UNKNOWN";

	return(name);
}



/******************************************************************************
*
*	Function:	aiss8ao4_reg_list
*
*	Purpose:
*
*		List the GSC registers and their values.
*
*	Arguments:
*
*		fd		The handle to access the device.
*
*		detail	List the register details?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int aiss8ao4_reg_list(int fd, int detail)
{
	int	errs;

	errs	= gsc_reg_list(fd, _gsc, detail, aiss8ao4_reg_read);
	return(errs);
}


